/************************* -*- Mode: C -*- *****************************
 *
 * viffutil.h -- utility functions for viff
 *
 * Copyright (C) 1996-1997 Richard Flamsholt S0rensen.  All rights reserved.
 *
 * Author          : Richard Flamsholt S0rensen
 * Created On      : Wed Dec 18 16:08:18 1996
 * Last Modified By: Richard Flamsholt S0rensen
 * Last Modified On: Fri Nov 07 11:50:42 1997
 * Update Count    : 8
 * Revision History: None
 *
 * COMMENTS
 * HISTORY
 **********************************************************************/

void error(const char *fmt, ...);
void panic(const char *fmt, ...);

void brief_usage(void);
void extended_usage(void);

int message(const char *fmt, ...);
BOOLEAN input(int flag, char *buf, const char *fmt, ...);
int ask(char *text[], int nlines, char *accept, char escape, const char *fmt, ...);

char *my_strerror(void);
BOOLEAN is_dir(char *fname);
char *make_path(char *buf, char *fname);
char *strip_path(char *fname);
char *lower_str(char *str);

BOOLEAN find_diffcmd(void);

void construct_argv(char *dir1, char *dir2, int *argcp, char ***argvp);
void skip_directories(int from, int to, char *argv[]);
void skip_generated_files(int from, int to, char *argv[]);
void skip_binary_files(int from, int to, char *argv[]);

void *xmalloc(size_t size);
void *xrealloc(void *ptr, size_t size);
char *xstrdup(char *str);

#ifdef MALLORY_FLAG
#define xmalloc(siz)    MAL_TRACE(voidptr,xmalloc(siz))
#define xrealloc(p,siz) MAL_TRACE(voidptr,xrealloc(p,siz))
#define xstrdup(s)      MAL_TRACE(voidptr,xstrdup(s))
#endif
